{*************************************
  2003.10.08 'FileReadStr' update
  2003.07.23 'DirCreate' update
  2003.02.24 port on DOS32/WIN32
*************************************}
Unit plFile;

Interface

Const
     {  }
     CReadOnly  = 0;    { }
     CWriteOnly = 1;    { }
     CReadWrite = 2;    {  }
     {    }
     CDenyAll   = 8;    {  }
     CDenyWrite = 16;   {}
     CDenyRead  = 24;   {}
     CDenyNone  = 32;   {}

Type
    FByte = File Of Byte;

Function FileOpen(Var F:FByte;B:Byte;S:String):Integer;
Function FileRead(var F:FByte;P:PByte;Count:longint):Integer;
Function FileReadStr(var F:FByte;Count:Byte):String;
Function FileWrite(var F:FByte;P:PByte;Count:longint):Integer;
Function SetFAttr(const S:String; Attr:Word):Word;
Function GetFAttr(const S:String):Word;
Function DirCreate(s:String):Integer;

Implementation

Function FileOpen(Var F:FByte;B:Byte;S:String):Integer;
{----------[   S <- F    B
}
Begin
     Assign(F,s);
     FileMode:=B;
     {$I-}
     Reset(F);
     {$I+}
     FileOpen:=IOResult;
End; {FileOpen}

Function FileRead(var F:FByte;P:PByte;Count:longint):Integer;
{----------[    F Count   P^
              Count=0   
}
Var oldRecLen:longint;
    b:Byte;
Begin
     If Count=0 Then Begin
        {$I-}
        Read(F,b);
        {$I+}
        FileRead:=IOResult;
        P^:=b;
        Inc(P);
        Count:=b;
     End;
     oldrecLen:=TFileRec(F).RecSize;
     TFileRec(F).RecSize:=Count;
     {$I-}
     Read(F,P^);
     {$I+}
     FileRead:=IOResult;
     TFileRec(F).RecSize:=oldrecLen;
End; {FileRead}

function FileReadStr(var F:FByte;Count:Byte):String;
var s:string;
begin
 SetLength(s,Count);
 if FileRead(F,@s[1],Count)<>0 then s:='';
 FileReadStr:=s;
end;

Function FileWrite(var F:FByte;P:PByte;Count:longint):Integer;
{----------[    F Count   P^
              Count=0   
}
Var oldRecLen:longint;
    b:Byte;
Begin
     If Count=0 Then Begin
        b:=P^;
        Inc(P);
        Count:=b;
        {$I-}
        Write(F,b);
        {$I+}
        FileWrite:=IOResult;
     End;
     oldrecLen:=TFileRec(F).RecSize;
     TFileRec(F).RecSize:=Count;
     {$I-}
     Write(F,P^);
     {$I+}
     FileWrite:=IOResult;
     TFileRec(F).RecSize:=oldrecLen;
End; {FileWrite}

Function DirCreate(s:String):Integer;
{----------[      S
                 '\'
}
var s1:string;
    i,err:integer;
begin
 s1:='';
 err:=0;
 while pos('/',s)>0 do s[pos('/',s)]:='\';
 i:=pos(':\',s);
 if i>0 then begin
  s1:=copy(s,1,i+1);
  s:=copy(s,i+2,length(s)-i+1);
 end;
 repeat
  i:=pos('\',s);
  if i>0 then begin
   s1:=s1+copy(s,1,i-1);
   s:=copy(s,i+1,length(s)-i);
   {$I-} MkDir(s1); {$I+}
   err:=IOResult;
   if err=183 then err:=0;
   s1:=s1+'\';
  end;
 until (i=0)or(err<>0);
 DirCreate:=err;
end; {DirCreate}

Function SetFAttr(const S: String; Attr: Word) : Word; assembler;
asm
  push ds
  mov  edx, S
  inc  edx
  mov  cx, Attr
  mov  eax, 4301h
  int  21h
  jc   @@1
  xor  eax,eax
@@1:
  pop  ds
end;

Function GetFAttr(const S: String): Word; assembler;
asm
  push ds
  mov  edx, S
  inc  edx
  mov  eax, 4300h
  int  21h
  pop  ds
  mov  eax, ecx
end;

end.