{2003.11.23 - port to FPC}
{2003.07.19}
{2003.03.24}
program ampenc2;
uses ampcrypt, plFile, SysUtils;
const sig  = 'AMPL'#0#0;
      endl = '#ENDL';
      endc = 'EndOfCFG';
      {endp = '*#ENDPICLIST#*';}
      splitter:string[1] = #0;
type  PPage = ^TPage;
      TPage = record
              next:PPage;
              CP:LongInt;
              P,FN:string;
              II:byte;
      end;
      PList = ^TList;
      TList = record
              next:PList;
              level:LongInt;
              level2:LongInt;
              F,N:string;
      end;
var F:Text;
    out:longint;
    s,olds1,s1,sCD,sCDRUS,sTitle:string;
    count1,currlevel:word;
    count2,count3,count4:LongInt;
    flag:LongInt;
    Key,CharSet,TextLang:byte;
    i,err:integer;
    fPage,cPage:PPage;
    fList,cList:PList;

procedure die(s:string);
begin
 writeln(s);
 halt(1);
end;

function ltrim(s:string):string;
begin
     while(byte(s[0])>0)and((s[1]=' ')or(s[1]=#9))do
          s:=copy(s,2,byte(s[0])-1);
     ltrim:=s;
end;

function rtrim(s:string):string;
begin
     while(byte(s[0])>0)and((s[byte(s[0])]=' ')or(s[byte(s[0])]=#9))do
          dec(byte(s[0]));
     rtrim:=s;
end;

function cut(s:string):string;
begin
     if s[1]=#39 then s:=copy(s,2,byte(s[0])-1);
     if s[byte(s[0])]=#39 then dec(byte(s[0]));
     cut:=s;
end;

procedure FreePage(var p:PPage);
var q:PPage;
begin
     while p<>nil do begin
      q:=p^.next;
      dispose(p);
      p:=q;
     end;
end;

function NewPage(var p:PPage;s:string):boolean;
var b,b1,b2:byte;
    q:PPage;
begin
     NewPage:=false;
     q:=p;
     new(p);
     if p=nil then die('Memory allocation error: '+s);
     if q<>nil then q^.next:=p;
     p^.next:=nil;
     b:=Pos('FN=',s);
     if b=0 then exit;
     p^.P:=cut(ltrim(rtrim(copy(s,3,b-3))));
     s:=copy(s,b,byte(s[0])-(b-1));
     b1:=Pos('II=',s);
     b2:=Pos('CP',s);
     if (b1=0)and(b2=0)then b:=byte(s[0]) else begin
      if b1<b2 then b:=b1 else b:=b2;
      dec(b);
     end;
     p^.FN:=cut(ltrim(rtrim(copy(s,4,b-3))));
     {s:=(copy(s,b+1,byte(s[0])-b));}
     if b1=0 then p^.II:=0 else begin
      if b2=0 then b:=byte(s[0])-(b1-1) else b:=b2-b1;
      Val(ltrim(rtrim(copy(s,b1+3,b-3))),p^.II,err);
      if err<>0 then exit;
     end;
     if b2=0 then p^.CP:=0 else begin
      Val(ltrim(rtrim(copy(s,b2+3,byte(s[0])-(b2-1)-3))),p^.CP,err);
      if err<>0 then {exit}p^.CP:=1;
     end;
     NewPage:=true;
end;

procedure FreeList(var p:PList);
var q:PList;
begin
     while p<>nil do begin
      q:=p^.next;
      dispose(p);
      p:=q;
     end;
end;

procedure NewList(var p:PList;s:string);
var b,b1:byte;
    q:PList;
begin
     q:=p;
     new(p);
     if p=nil then die('Memory allocation error: '+s);
     if q<>nil then q^.next:=p;
     p^.next:=nil;
     b:=Pos(splitter,s);
     if b=0 then die('Splitter not found: '+s);
     if s[2]='N' then begin
      b1:=4;
      p^.level:=currlevel;
      p^.level2:=2;
     end else if s[2]='F' then begin
      b1:=4;
      p^.level:=0;
      p^.level2:=16;
     end else begin
      b1:=3;
      p^.level:=currlevel;
      p^.level2:=1;
     end;
     p^.F:=ltrim(rtrim(copy(s,b1,b-b1)));
     s:=ltrim(rtrim(copy(s,b+1,byte(s[0])-b)));
     b:=Pos('N=',s);
     if b=0 then die('Name not found: '+s);
     p^.N:=ltrim(copy(s,b+2,byte(s[0])-b-1));
end;

begin
 Writeln('Advanced Musical Player''s cfg-files encoder 2.2 by Paul Lee (c) 2003');
 if ParamCount=0 then begin
    Writeln;
    Writeln('   Usage: ampenc2.exe <in-file> [<out-file> [<splitter>]]');
    Writeln;
    exit;
 end;
 Assign(F,ParamStr(1));
 Reset(F);
 if ParamCount<2 then s:='out.cfg' else s:=ParamStr(2);
 out:=FileCreate(s);
 if out<>-1 then begin
  if ParamCount>2 then splitter:=ParamStr(3);
 {--------------------------------------------}
  s:='';sCD:='';sCDRUS:='';sTitle:='';Key:=13;
  flag:=0;CharSet:=0;TextLang:=0;err:=0;
  count1:=0;count2:=0;count3:=0;count4:=0;
  fPage:=nil;cPage:=nil;fList:=nil;cList:=nil;

 {--------------------------------------------}
  while not(eof(F))do begin
   readln(F,s);
   s:=ltrim(rtrim(s));
   if copy(s,1,length(endc))=endc then break
   else if copy(s,1,3)='CD='then sCD:=ltrim(copy(s,4,byte(s[0])-3))
   else if copy(s,1,6)='CDRUS='then sCDRUS:=ltrim(copy(s,7,byte(s[0])-6))
   else if (copy(s,1,4)='PVT=') then begin if(ltrim(copy(s,5,byte(s[0])-4))='1')
    then flag:=SetBit(flag,0)   end
   else if (copy(s,1,5)='PSSH=')then begin if(ltrim(copy(s,6,byte(s[0])-5))='1')
    then flag:=SetBit(flag,1)   end
   else if (copy(s,1,4)='PVV=') then begin if(ltrim(copy(s,5,byte(s[0])-4))='1')
    then flag:=SetBit(flag,2)   end
   else if (copy(s,1,3)='DL=')  then begin if(ltrim(copy(s,4,byte(s[0])-3))='1')
    then flag:=SetBit(flag,3)   end
   else if (copy(s,1,3)='F5=')  then begin if(ltrim(copy(s,4,byte(s[0])-3))='1')
    then flag:=SetBit(flag,5)   end
   else if (copy(s,1,3)='F6=')  then begin if(ltrim(copy(s,4,byte(s[0])-3))='1')
    then flag:=SetBit(flag,6)   end
   else if (copy(s,1,3)='BS=')  then begin if(ltrim(copy(s,4,byte(s[0])-3))='1')
    then flag:=SetBit(flag,7)   end
   else if (copy(s,1,4)='BSV=') then begin if(ltrim(copy(s,5,byte(s[0])-4))='1')
    then flag:=SetBit(flag,9)   end
   else if copy(s,1,8)='Charset='then begin
    Val(ltrim(copy(s,9,byte(s[0])-8)),CharSet,err);
    if err<>0 then die('Error in string: '+s);
   end else if copy(s,1,13)='TextLanguage='then begin
    Val(ltrim(copy(s,14,byte(s[0])-13)),TextLang,err);
    if err<>0 then die('Error in string: '+s);
   end else if copy(s,1,2)='T='then sTitle:=ltrim(copy(s,3,byte(s[0])-2))
   else if copy(s,1,2)='P='then begin
    if cPage=nil then cPage:=fPage;
    if not NewPage(cPage,s) then die('Error in string: '+s);
    if fPage=nil then fPage:=cPage;
    inc(count1);
   end else if (copy(s,1,3)='ET=')then writeln('Tag '+s+' not supported')
   else if (s<>'')or(s[1]<>';')then die('Unknown tag present: '+s);
  end;
  if copy(s,1,length(endc))<>endc then die(endc+' not present.');
  olds1:='';
  while not(eof(F))do begin
   readln(F,s);
   s:=ltrim(rtrim(s));
   if s=endl then break
   else begin
    s1:=copy(s,1,2);
    if(s1='F=')or(s1='FN')or(s1='MF')then begin
     if(s1='MF')or(olds1='')then currlevel:=0
     else if(s1='F=')then begin
      if(olds1='FN')then dec(currlevel)else inc(currlevel)
     end else if(olds1='FN')then else inc(currlevel);
     olds1:=s1;
     if cList=nil then cList:=fList;
     NewList(cList,s);
     if fList=nil then fList:=cList;
     inc(count2);
    end else if not((s='')or(s[1]=';'))then
      die('Unknown tag present: '+s);
   end
  end;
  if s<>endl then writeln('Warning: '+endl+' not present.');
 {--------------------------------------------}
  s:=sig+#1#0;
  FileWrite(out,s[1],8);
  EncryptStr(out,Key,1,sCD);
  EncryptStr(out,Key,1,sCDRUS);
  EncryptDword(out,Key,flag);
  byte(s[0]):=6;
  EncryptStr(out,Key,1,s);
  EncryptStr(out,Key,2,sTitle);
  EncryptByte(out,Key,CharSet);
  EncryptByte(out,Key,TextLang);
  EncryptWord(out,Key,count1);
  cPage:=fPage;
  while cPage<>nil do begin
   EncryptDword(out,Key,cPage^.CP);
   EncryptStr(out,Key,1,cPage^.P);
   EncryptStr(out,Key,1,cPage^.FN);
   EncryptByte(out,Key,cPage^.II);
   EncryptByte(out,Key,0);
   cPage:=cPage^.next;
  end;
  EncryptDword(out,Key,count2);
  cList:=fList;
  while cList<>nil do begin
   EncryptWord(out,Key,cList^.level);
   EncryptDword(out,Key,cList^.level2);
   EncryptStr(out,Key,2,cList^.N);
   EncryptStr(out,Key,2,cList^.F);
   cList:=cList^.next;
  end;
  s:=endl;
  EncryptWord(out,Key,word(-1));
  EncryptDword(out,Key,15);
  EncryptStr(out,Key,2,s);
 {--------------------------------------------}
  FreeList(fList);
  FreePage(fPage);
 end;
 FileClose(out);
 Close(F);
end.
